program NkMon;

{$R *.RES}

uses NLib, NSys, NArgParser, NForm, NCommand, NConf, MainForm, Monitor;

var
  opt: Char;
begin
  App.Name := 'NkMon';

  ProfDir := GetEnv('NKTOOLSPROF');
  if ProfDir = '' then
    ProfDir := DirName(ProgPath)
  else
    ProfDir := JoinPath([ProfDir, 'nkmon']);

  with ArgParser do
  begin
    while GetOpt(opt) do
      case opt of
        'd': ProfDir := GetArg;
        'p': Monitor.UdpReceiverPort := SInt(GetArg);
      else
        App.Error('usage: nkmon [-d profdir] [-p port]');
        Exit;
      end;
    Argv := Args;
  end;

  ProfDir := AbsPath(ProfDir);
  try
    with TListDir.Create(ProfDir) do
      Free;
  except
    on E: EIOError do
      App.Error(FormatException(E));
  end;

  Config := TConf.Create;
  Config['x'] := StringArray(['0']);
  Config['y'] := StringArray(['0']);
  Config.LoadFromFile(JoinPath([ProfDir, 'position']));

  App.MainForm := TNkMonMainForm.Create;
  Command := TCommand.Create(App.MainForm);
  ExitCode := App.Run;

  App.MainForm.Free;
  Command.Free;
  Config.Free;
end.
